// debug.c

#include "compile.h"

#ifdef DEBUG

#define		MAXSPY		100
#define		MAXTRACE	1000
#define		MAXCALL		1000

int spycnt[MAXSPY];
int traceflag;
int iptrace[MAXTRACE], trptr, trlen;
int calltrace[MAXCALL], clevel[MAXCALL], calltr, ctrlen, levels;

extern int M[], SS[], CS[];
extern int ac, fp, sp;

#endif

// -------------------------

#ifdef PROF

int icnt[100], lcnt[15000];
int OP, IP;

void stat(void){
	icnt[OP]++;
	if(IP < 15000) lcnt[IP]++;
}

void report2(void){
	int i, s;
	s = 0;
	for(i=1; i<EOC; i++)
		if(icnt[i] != 0){
//			prCode2(stdout,i);
			printf("%d %d\n",i,icnt[i]);
			s += icnt[i];
		}
	printf("total %d\n",s);

	s = 0;
	for(i=2; i<CP; i+=2)
		if(lcnt[i] != 0){
			s += lcnt[i];
			printf("%d %d\n",i,lcnt[i]);
		}
	printf("total %d\n",s);

}

#endif

// ------- end prof ---------------


// !!! debug

extern FILE *FO;
extern int lv;

#ifdef DEBUG

void report(void){
	int i,k;
	if ( traceflag ) {
	// print ip trace  max .. min
	printf("%d\n",trlen);
	k = trptr-trlen;
	if( k < 0 ) k += MAXTRACE;
	for(i=0; i<trlen; i++){
		printf("%d ",iptrace[k]);
		if( (i % 10) == 0) printf("\n");
		k++;
		k %= MAXTRACE;
	}
	printf("\n");
	// print call trace
	printf("%d\n",ctrlen);
	for(i=0; i<ctrlen; i++)
		printf("%d %d\n",clevel[i],calltrace[i]);
	printf("\n");
	}
}
/*
int callstk[200], callstkptr = 0;

void pushcallstk(int x){
	callstkptr++;
	callstk[callstkptr] = x;
}

void popcallstk(void){ callstkptr--; }

void dumpcallstk(void){
	int i;
	printf("call stack :");
	for(i=1; i<=callstkptr; i++)
		printf("%d ",callstk[i]);
	nl();
}

void trace(void){
	int i, a, b;
//	printf("%5d ",ip);
//	prCode(ip);
	printf(" |");
	a = sp - 10;
	if( a < 0 ) a = 0;

	for(i=a; i<=sp; i++)
		if(i == fp)
			printf("[%d] ",SS[i]);
		else
			printf("%d ",SS[i]);
	printf("\n");
}

void dumpDS(void){
	int i;
	for(i=1; i<10; i++)	printf("%d:%d ",i,M[i]);
	printf("\n");
}

void dumpstack(void){
	int i, a;

	a = sp - 10;
	if( a < 0 ) a = 0;
	printf("\n> %d: ",a);
	for(i=a; i<=sp; i++)
		if(i == fp)
			printf("[%d] ",SS[i]);
		else
			printf("%d ",SS[i]);
	printf("<%d>\n",ac);
}
*/

void makecall(int a){
	if (traceflag) {
		// keep trace of call
		calltrace[calltr] = a;
		levels++;
		clevel[calltr] = levels;
		ctrlen++;
		if( ctrlen >= MAXCALL ) ctrlen = MAXCALL;
		calltr++;
		calltr %= MAXCALL;
	}
}

void makeret(void){
	if (traceflag) {
		levels--;
	}
}

void spy(int ip){
	if (traceflag) {
		// keep trace of ip
		iptrace[trptr] = ip;
		trlen++;
		if( trlen >= MAXTRACE ) trlen = MAXTRACE;
		trptr++;
		trptr %= MAXTRACE;
	}
}

#endif

//	int i;
//	printf("ac %d, ", AC);
//	printf("sp %d, fp %d\n", sp, fp);
//	for(i = 1000; i<1050; i++)
//		printf("%d:%d ",i,M[i]);
//	printf("[%d %d] ",F[1],F[2]);
//	printf("[%d %d. 5:%d 6:%d] ",SS[sp-1],SS[sp],F[5],F[6]);
//	printf("[2:%d 4:%d] ",F[2],F[4]);
/*
	printf("<< ");
	for(i = fp; i < fp+15; i++)
		if( i == sp ) printf("[%d] ",SS[i]);
		else printf("%d ",SS[i]);
	printf(">> ");
*/
